/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */



#ifndef _Conf_h_
#define _Conf_h_ 1

#include 	"Global.h"
#include 	"Thread.h"
#include 	"String.h"

#include <stdio.h> /* FILE, fopen */


#define MAXCONFENTRIES	300	

class Log;

class Conf {
	Mutex   confLock;
	String 	confFile;
	FILE 	*file;
	String  configValues[MAXCONFENTRIES][2];
	int 	size;

	int openFile();
	int closeFile();
	int getKeyPrm(String *key_str,String *prm_str);

public:
        Conf(String confFile_t = "/etc/proxyd.conf");
        ~Conf();

	/*
	 * writes all key->value pairs to the log.
	 */
	int log();

	/*
	 * Reads the configuration from a file.
 	 */
	int read();

	/*
	 * Gets an int value for the specified key.
	 * returns -1 if key was not found.
	 */
	int getValAsInt(String key);

	/*
	 * Gets an ip value for the specified key.
	 * returns 0 if key was not found.
	 */
	int Conf::getValAsIP(String key);

	/*
	 * Gets an string value for the spcified key.
	 * returns an empty string if key was not found.
	 */
	String getValAsString(String key);


	int setKeyPrm(String key,String prm);
};

#endif /* _Conf_h_ */
