/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */

#ifndef _FirewallControl_h_
#define _FirewallControl_h_ 1

#include "Global.h"
#include "Thread.h"
#include "String.h"

class Connection;
class Fwfil;

#define MAXFWRULES MAXPROXIES*MAXSESSIONS*20 

class FirewallControl : public Thread {
        Mutex   	fwcLock;
	Fwfil*        	fwfilList[MAXFWRULES];
	int		size;

	int fw_del_fil(Fwfil*  fwfilp);
	int fw_del_fil(int id);
	int fw_add_fil(Fwfil*  fwfilp);
	
	void main();

protected:
	String		type;
	virtual int fw_get_dst_x(Connection *sc,Connection *dc){};
	virtual int fw_get_chl_x(Fwfil *fwfilp){};
	virtual int fw_del_chl_x(Fwfil *fwfilp){};
	
public:
        FirewallControl();
        ~FirewallControl();

	int fw_get_dst(Connection *sc,Connection *dc);
	int fw_get_chl(Fwfil *fwfilp);
	int fw_del_chl(Fwfil *fwfilp);
	int fw_del_chl(int id);
	int fw_del_chl();

	int log(int loglevel);
};

#endif /* _FirewallControl_h_ */
