/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */





#include "Fwfil.h"
#include "FirewallControl.h"
#include "Connection.h"
#include "Log.h"

#include <sys/socket.h> /* inet_ntoa */
#include <netinet/in.h> /* inet_ntoa */
#include <arpa/inet.h> /* inet_ntoa */



Fwfil::Fwfil(Connection *c,bool todest){
        id	 = -1;
	descript = c->d_name;
       	ipproto	 = c->ipproto;
       	tcpf 	 = 0;
       	if (ipproto==6) tcpf |= TH_ACK;
       	if (!((c->direction) ^ (todest))){
                	srchost=c->l_ip;
                	srcmask=c->l_mask;
                	if ((c->l_port)==-1) {
                        	srcportrange = FWFIL_PORTRANGE_GREATERT;
                        	srcport      = 1023;
                	}
                	else {
                        	srcportrange = FWFIL_PORTRANGE_EQUAL;
                        	srcport      = c->l_port;
                	}
                	dsthost=c->p_ip;
                	dstmask=c->p_mask;
                	if ((c->p_port)==-1) {
                        	dstportrange = FWFIL_PORTRANGE_GREATERT;
                        	dstport      = 1023;
                	}
                	else {
                        	dstportrange = FWFIL_PORTRANGE_EQUAL;
                        	dstport      = c->p_port;
                	}
       	}
       	else if (((c->direction) ^ (todest))){
                	dsthost=c->l_ip;
                	dstmask=c->l_mask;
                	if ((c->l_port)==-1) {
                        	dstportrange = FWFIL_PORTRANGE_GREATERT;
                        	dstport      = 1023;
                	}
                	else {
                        	dstportrange = FWFIL_PORTRANGE_EQUAL;
                        	dstport      = c->l_port;
                	}
                	srchost=c->p_ip;
                	srcmask=c->p_mask;
                	if ((c->p_port)==-1) {
                        	srcportrange = FWFIL_PORTRANGE_GREATERT;
                        	srcport      = 1023;
                	}
                	else {
                        	srcportrange = FWFIL_PORTRANGE_EQUAL;
                        	srcport      = c->p_port;
                	}
       	}
}

Fwfil::Fwfil(char *descript_t,int ipproto_t,int srchost_t,int srcmask_t,int srcportrange_t, int srcport_t,
                                           int dsthost_t,int dstmask_t,int dstportrange_t, int dstport_t){
        id=-1;
       	descript=String(descript_t);
       	ipproto=ipproto_t;
       	tcpf = 0;
       	if (ipproto==6) tcpf |= TH_ACK;
	srchost=srchost_t;
	srcmask=srcmask_t;
	srcportrange=srcportrange_t;
	srcport=srcport_t;
	dsthost=dsthost_t;
	dstmask=dstmask_t;
	dstportrange=dstportrange_t;
	dstport=dstport_t;
}

Fwfil::Fwfil(){
        id	 	= -1;
       	descript 	= String("UNSPECIFIED");
       	ipproto  	= 6;
       	tcpf     	= 0;
	tcpf |= TH_ACK;
	srchost  	= 0;
	srcmask  	= 0;
	srcport  	= 1023;
	srcportrange 	= FWFIL_PORTRANGE_GREATERT;
	dsthost		= 0;
	dstmask		= 0;
	dstport		= 1023;
	dstportrange	= FWFIL_PORTRANGE_GREATERT;
}

Fwfil::~Fwfil(){
}

int Fwfil::log(int loglevel){
        MUTEX_AUTO_LOCK(fwfilLock);

	String from = String::IPtoString(srchost) + "/" + String::IPtoString(srcmask);
        if (srcportrange==FWFIL_PORTRANGE_NONE)     from = from + " ";
        if (srcportrange==FWFIL_PORTRANGE_EQUAL)    from = from + " port = ";
        if (srcportrange==FWFIL_PORTRANGE_NEQUAL)   from = from + " port != ";
        if (srcportrange==FWFIL_PORTRANGE_GREATERT) from = from + " port > ";
	from = from + srcport;

	String to = String::IPtoString(dsthost) + "/" + String::IPtoString(dstmask);
        if (dstportrange==FWFIL_PORTRANGE_NONE)     to = to + " ";
        if (dstportrange==FWFIL_PORTRANGE_EQUAL)    to = to + " port = ";
        if (dstportrange==FWFIL_PORTRANGE_NEQUAL)   to = to + " port != ";
        if (dstportrange==FWFIL_PORTRANGE_GREATERT) to = to + " port > ";
	to = to + dstport;

        LOG((__FILE__,__FUNCTION__,loglevel,"     FILTERSPEC: ID=%d DESCRIPT=%s proto %d from %s to %s\n",id, descript.c_str(), ipproto, from.c_str(), to.c_str()))
        return (0);
}




