/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */


#ifndef _Fwfil_h_
#define _Fwfil_h_ 1

#include 	"Global.h"
#include 	"Thread.h"
#include	"String.h"

#define FWFIL_PORTRANGE_NONE            0
#define FWFIL_PORTRANGE_EQUAL           1
#define FWFIL_PORTRANGE_NEQUAL          2
#define FWFIL_PORTRANGE_LESST           3
#define FWFIL_PORTRANGE_GREATERT        4

#define TH_FIN  0x01
#define TH_SYN  0x02
#define TH_RST  0x04
#define TH_PUSH 0x08
#define TH_ACK  0x10
#define TH_URG  0x20

class Connection;

class Fwfil{
	Mutex           fwfilLock;

public:
        int	        id;
	String		descript;
        int       ipproto;
        int       srchost;
        int       srcmask;
        int       srcportrange;
        int       srcport;
        int       dsthost;
        int       dstmask;
        int       dstportrange;
        int       dstport;
        int       tcpf;

	Fwfil(Connection *c,bool todest);
	Fwfil(char *descript_t,int ipproto_t,int srchost_t,int srcmask_t,int srcportrange_t, int srcport_t, int dsthost_t,int dstmask_t,int dstportrange_t, int dstport_t);
	Fwfil();
	~Fwfil();

	int log(int loglevel);
};


#endif /* _Fwfil_h_ */
