/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#include "Fwhndl.h"
#include "Fwfil.h"
#include "FirewallControl.h"
#include "Log.h"

Fwhndl::Fwhndl(){
	for(int i=0;i<MAXRULES;++i){
               	rList[i]=-1;
       	}
}
Fwhndl::~Fwhndl(){
	delAllChannel();
}

int Fwhndl::getChannel(Fwfil *fwfilp){
       	if((Global::getGlobal()->getFirewallControl()->fw_get_chl(fwfilp))<0){
               	ERR((__FILE__,__FUNCTION__,"could not add rule to firewall\n"))
               	return(-1);
       	}
       	for(int i=0;i<MAXRULES;++i){
               	if (rList[i]<0) {
                       	rList[i]=fwfilp->id;
                       	return(0);
               	}
       	}
       	FAT((__FILE__,__FUNCTION__,"could not add rule to firewall, MAXRULES reached\n"))
       	return(-1);
}

int Fwhndl::delAllChannel(){
	for(int i=0;i<MAXRULES;++i){
		if (rList[i]>=0) {
			if((Global::getGlobal()->getFirewallControl()->fw_del_chl(rList[i]))<0){
				ERR((__FILE__,__FUNCTION__,"could not remove rule from firewall\n"))
				return(-1);
			}
		else rList[i]=-1;
		}
	}
	return(0);
}
