/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */

#include "Global.h"
#include "Log.h"
#include "Conf.h"
#include "ListenerList.h"
#include "FirewallControl.h"
#include "Proxy.h"
#include "Thread.h"
#include "ProxyList.h"

/*
 * Initialization of the static field global.
 */
Global* Global::global = NULL;


Global::Global():end(false),mainThreadID(0),log(NULL), conf(NULL), lst(NULL), fwc(NULL), proxyList(NULL){
}


Global* Global::getGlobal(){
	if(global==NULL){
		global = new Global();
	}
	return global;
}

void Global::setEnd(bool end_t){
	end=end_t;
}

void Global::setmainThreadID(int id_t){
	mainThreadID=id_t;
}

void Global::setLog(Log* log_t){
	if ((log_t==NULL) && (log!=NULL)){
		delete log;
	}
	log=log_t;
}
void Global::setConf(Conf* conf_t){
	if ((conf_t==NULL) && (conf!=NULL)){
		delete conf;
	}
	conf=conf_t;
}
void Global::setFirewallControl(FirewallControl* fwc_t){
	if ((fwc_t==NULL) && (fwc!=NULL)){
		delete fwc;
	}
	fwc=fwc_t;
}
void Global::setListenerList(ListenerList* lst_t){
	if ((lst_t==NULL) && (lst!=NULL)){
		delete lst;
	}
	lst=lst_t;
}
void Global::setProxyList(ProxyList* proxyList_t){
	if ((proxyList_t==NULL) && (proxyList!=NULL)){
		delete proxyList;
	}
	proxyList=proxyList_t;
}

bool Global::getEnd(){
	return end;
}
int Global::getmainThreadID(){
	return mainThreadID;
}

Log* Global::getLog(){
	return log;
}
Conf* Global::getConf(){
	return conf;
}
ListenerList* Global::getListenerList(){
	return lst;
}
FirewallControl* Global::getFirewallControl(){
	return fwc;
}

ProxyList* Global::getProxyList(){
	return proxyList;
}

