/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */





#ifndef _Global_h_
#define _Global_h_ 1

#include "String.h"

#include <config.h>

#define BUFFERSIZE 		1514	
#define MAXPROXIES		2	/* must be >=1 */	
#define MAXLISTENERS		5	/* must be >=1 */	
#define MAXLOCATORS		30	/* must be >=1 */	
#define MAXSESSIONS		10	/* must be >=1 */	
#define MAXCONNECTIONS		100	/* must be >=1 */

#define VERSION			"KOMproxyd 1.0.4"
#define AUTHOR			"Utz Roedig"


class  Conf;
class  Log;
class  ListenerList;
class  FirewallControl;
class  Proxy;
class  Parser;
class  ProxyList;
class  Session;


typedef FirewallControl* (*FWMakerType)(String type_t);
typedef Parser* 	 (*PMakerType)(Session* parent_t,String type_t);


/*
 * The class Global holds all objects that were needed by
 * by the program. It is implemented as singleton.
 */
class Global {

private:
	static Global* global;

	Mutex  			globalLock;
	bool			end;
	int 			mainThreadID;
	Log* 			log;
	Conf* 			conf;
	ListenerList*		lst;
	FirewallControl*	fwc;
	ProxyList*		proxyList;

	Global();

public:
	static Global* getGlobal();
	
	void		setEnd(bool end_t);	
	void		setmainThreadID(int id_t);
	void		setLog(Log* log_t);	
	void		setConf(Conf* conf_t);
	void		setListenerList(ListenerList* lst_t);
	void		setFirewallControl(FirewallControl* fwc_t);
	void		setProxyList(ProxyList* proxyList_t);

	bool			getEnd();	
	int			getmainThreadID();	
	Log*			getLog();	
	Conf*			getConf();	
	ListenerList*		getListenerList();	
	FirewallControl*	getFirewallControl();	
	ProxyList*		getProxyList();	


};
#endif
