/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */




#ifndef _ListenerList_h_
#define _ListenerList_h_ 1

#include "Global.h"
#include "Thread.h"
#include "Listener.h"
#include "Session.h"

class Log;
class Conf;

class ListenerList : public Thread{

private:
	Mutex  		listenerListLock;
	Listener*		listenerList[MAXLISTENERS];

	int             size;    

	int addListenerInternal(Listener* l);
        int delListenerInternal(Listener* l);
        int delListenerInternal();

	void    main();

public:
	ListenerList();
	~ListenerList();

	int 	addListener(Listener* l);
        int 	delListener(Listener* l);
        int 	delListener();
        int 	getSize();

	int 	log(int loglevel);
};
#endif
