/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#ifndef _Log_h_
#define _Log_h_ 	1
#define _USE_LOG_ 	1

#include "Global.h"
#include "Thread.h"
#include "String.h"

#include <stdio.h> /* FILE, fopen */
#include <stdarg.h> /*vprintf*/

class Log {
	Mutex	logLock;
	String 	logDir;
	int    	logLevel;
	int    	logType;

	FILE 	*fp;

	int 	lograwprint(char *format,char *fmt,va_list ap);
	int 	logprint(char *format,const char *file,const char *function,char *fmt,va_list ap);
	int 	openlog();	
	int 	closelog();

public:
        Log(int logType_t = 0, int logLevel_t = 3, String logDir_t = "/tmp/");
        ~Log();

	int 	setLogtarget(int logType_t,String logDir_t);
        int 	setLoglevel(int logLevel_t);

        int 	log(const char *file,const char *function,int loglevel,char *fmt, ...);
        int 	inf(const char *file,const char *function,char *fmt, ...);
        int 	wrn(const char *file,const char *function,char *fmt, ...);
        int 	err(const char *file,const char *function,char *fmt, ...);
        int 	fat(const char *file,const char *function,char *fmt, ...);
        int 	lograw(char *fmt, ...);
};

#ifdef _USE_LOG_ 
#define LOG( args ) Global::getGlobal()->getLog()->log args ;
#define INF( args ) Global::getGlobal()->getLog()->inf args ;
#define WRN( args ) Global::getGlobal()->getLog()->wrn args ;
#define ERR( args ) Global::getGlobal()->getLog()->err args ;
#define FAT( args ) Global::getGlobal()->getLog()->fat args ; 
#else
#define LOG( args ) ;
#define INF( args ) Global::getGlobal()->getLog()->inf args ;
#define WRN( args ) Global::getGlobal()->getLog()->wrn args ;
#define ERR( args ) Global::getGlobal()->getLog()->err args ;
#define FAT( args ) Global::getGlobal()->getLog()->fat args ; 
#endif

#endif /* _Log_h_ */
