/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */



#include "Parser.h"
#include "Log.h"
#include "Session.h"
#include "Conf.h"
#include "FirewallControl.h"

Parser::Parser():parent(NULL){
}

Parser::~Parser() {
}
/*
int Parser::setParent(Session* parent_t){
        parent=parent_t;
        return(0);
}
*/

int Parser::connectDestinationFW(){
	if((parent->con[0][1]->connectionGetState())!=CONNECT){
	   LOG((__FILE__,__FUNCTION__,8,"LOCATOR:FW:\n"))
           if((Global::getGlobal()->getFirewallControl()->fw_get_dst(parent->con[0][0],parent->con[0][1]))<0){
                return(-1);
           }
	   if((parent->con[0][1]->connectionConnect())<0){
               	WRN((__FILE__,__FUNCTION__,"connecting destination for control channel\n"))
		return(-1);
	   }
	   LOG((__FILE__,__FUNCTION__,8,"LOCATOR:FW: using destination %s:%d for %s\n",
			(String::IPtoString(parent->con[0][1]->p_ip)).c_str(),
			parent->con[0][1]->p_port,
			(String::IPtoString(parent->con[0][0]->p_ip)).c_str()))

	   parent->data.dstIP=parent->con[0][1]->p_ip;
	   return(1);
	}
	else {
	   return(1);
	}
}

int Parser::connectDestinationCONF(){
	String locator;
        String requestIP;
        String requestPORT;
        String sourceIP;
        String confIP;

	if((parent->con[0][1]->connectionGetState())!=CONNECT){
	   LOG((__FILE__,__FUNCTION__,8,"LOCATOR:CONF:\n"))

	   sourceIP  = String::IPtoString((parent->con[0][0]->p_ip));
	   for (int i=0;i<MAXLOCATORS;++i){
		locator = type + "_LOCATOR" + "_CONF" + "_HOST" + "_" + i;
		confIP  = Global::getGlobal()->getConf()->getValAsString(locator);
		if (confIP!=String("")) {
			LOG((__FILE__,__FUNCTION__,8,"LOCATOR:CONF: testing %s = %s for %s\n",locator.c_str(),confIP.c_str(),sourceIP.c_str()))
			if(sourceIP==confIP){
				requestIP   = locator + "_IP";
				requestPORT = locator + "_PORT";
				if (((Global::getGlobal()->getConf()->getValAsString(requestIP))!=String("")) &&
					((Global::getGlobal()->getConf()->getValAsString(requestPORT))!=String(""))) {
					parent->con[0][1]->p_ip        = Global::getGlobal()->getConf()->getValAsIP(requestIP);
					parent->con[0][1]->p_mask      = 0xffffffff;
					parent->con[0][1]->p_port      = Global::getGlobal()->getConf()->getValAsInt(requestPORT);
					parent->con[0][1]->ipproto     = parent->con[0][0]->ipproto;
					if((parent->con[0][1]->connectionConnect())<0){
						WRN((__FILE__,__FUNCTION__,"connecting destination for control channel\n"))
						return(-1);
					}
					LOG((__FILE__,__FUNCTION__,8,"LOCATOR:CONF: using destination %s:%d for %s\n",
							(String::IPtoString(parent->con[0][1]->p_ip)).c_str(),
							parent->con[0][1]->p_port,sourceIP.c_str()))

					parent->data.dstIP=parent->con[0][1]->p_ip;
					return(1);
				}
				else {
					WRN((__FILE__,__FUNCTION__,"LOCATOR:CONF: configuration file incomplete: KEY=%s VAL=%s KEY=%s VAL=%s\n",
						requestIP.c_str()  ,Global::getGlobal()->getConf()->getValAsString(requestIP).c_str(),
						requestPORT.c_str(),Global::getGlobal()->getConf()->getValAsString(requestPORT).c_str()))
				}
			}
		}
	   }
	   return(-1);
	}
	else {
	   return(1);
	}
}

int Parser::connectDestination(String locator){
        if (locator==String("FW"))      return(connectDestinationFW());
        if (locator==String("CONF"))    return(connectDestinationCONF());
        return connectDestinationSPECIAL(locator);
}

int Parser::connectDestination(){
        int 	ret;
	String 	locator;
       	for (int i=0;i<MAXLOCATORS;++i){
               	locator = type + "_LOCATOR" + "_" + i;
               	if ((Global::getGlobal()->getConf()->getValAsString(locator))!=String("")) {
                       	if((ret=connectDestination(Global::getGlobal()->getConf()->getValAsString(locator)))>=0) return (ret);
               	}
       	}
	return(-1);
}
