/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#ifndef _Parser_h_
#define _Parser_h_ 1

#include "Global.h"
#include "Connection.h"
#include "String.h"

class Session;

class Parser {

protected:
	Session*  parent;
	String type;
	
	int connectDestinationFW();
	int connectDestinationCONF();
	int connectDestination(String locator);
	int connectDestination();

public:
	Parser();
	virtual ~Parser();

	//int setParent(Session* parent_t);

	virtual int connectDestinationSPECIAL(String locator){};
	virtual int connectDestinationFAST(){};

	virtual int read_0(Connection *c){};
	virtual int read_1(Connection *c){};
	virtual int read_2(Connection *c){};
	virtual int read_3(Connection *c){};
	virtual int read_default(Connection *c){};

	virtual int write_0(Connection *dc,Connection *sc){};
	virtual int write_1(Connection *dc,Connection *sc){};
	virtual int write_2(Connection *dc,Connection *sc){};
	virtual int write_3(Connection *dc,Connection *sc){};
	virtual int write_default(Connection *dc,Connection *sc){};

	virtual int parse_00(Connection *c){};
	virtual int parse_10(Connection *c){};
	virtual int parse_20(Connection *c){};
	virtual int parse_30(Connection *c){};
	virtual int parse_default0(Connection *c){};
	virtual int parse_01(Connection *c){};
	virtual int parse_11(Connection *c){};
	virtual int parse_21(Connection *c){};
	virtual int parse_31(Connection *c){};
	virtual int parse_default1(Connection *c){};
};


#endif
