/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */

#ifndef _Proxy_h_
#define _Proxy_h_ 1

#include 	"Global.h"
#include	"Thread.h"
#include	"TimeValue.h"
#include	"String.h"

class Session;

class Proxy : public Thread{
	Mutex   	proxyLock;
	Session* 	sessionList[MAXSESSIONS];

	int 		transferPipe[2];
	int             size;                           /* the current size of sessionList */

        fd_set		setFD;
	fd_set  	workSetFD;
        int		maxFD;
	int		sizeFD;

	TimeValue	currTime;


	int             proxyInitSpecial();
	int             proxyInitSession();
        int             proxyInit();                   /* inits all necessary things before the main loop starts */
        int             proxyFinish();                 /* check which sessions finished and remove them from the sessionList */
        int             proxyRelaySpecialFD();
        int             proxyRelaySessionFD();
        int             proxyRelay();                  /* calls first proxyRelaySpecialFD then proxyRelaySessionFD */
	int 		proxySelect();

	int 		addSession(Session* s);
	int 		delSession(int id);
	int 		delSession(Session* s);
	int 		delSession();

	String 		getDescript();
	void 		main();
public:
	Proxy();
	~Proxy();

	int 		getSize();
	bool 		hasSpaceLeft();

	int 		getTransferFD();

	int 		log(int loglevel);

        fd_set*         getSetFD();
        int             getMaxFD();
        void            addFD(int fd);
        void            delFD(int fd);
};
#endif /* _Proxy_h_ */
