/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */




#ifndef _ProxyList_h_
#define _ProxyList_h_ 1

#include "Global.h"
#include "Thread.h"
#include "Proxy.h"
#include "Session.h"

class Log;
class Conf;

class ProxyList : public Thread{

private:
	Mutex  		proxyListLock;
	Proxy*		proxyList[MAXPROXIES];

	int             size;                           /* the current size of proxyList */

	int		fillmethod;

	int addProxyInternal(Proxy* p);
        int delProxyInternal(Proxy* p);
        int delProxyInternal();

	int queueSessionInProxy(Session *s,Proxy* p);
	int queueSessionFillFirst(Session *s);
	int queueSessionFillEqual(Session *s);

	void    main();

public:
	ProxyList();
	~ProxyList();

	int 	queueSession(Session *s);

	int 	addProxy(Proxy* p);
        int 	delProxy(Proxy* p);
        int 	delProxy();
        int 	getSize();
	bool 	hasSpaceLeft();

	int 	log(int loglevel);
};
#endif
