/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#ifndef _SessionData_h_
#define _SessionData_h_ 1

#include "Global.h"
#include "TimeValue.h"
#include "String.h"
#include "Log.h"


class SessionData {

public:
        int             read;
        int             write;
        String          srcUser;
        String          dstUser;
        int		srcIP;
        int		dstIP;
	TimeValue       start;
	String		type;

	SessionData(){
		read=0;
		write=0;
		srcIP=0;
		dstIP=0;
		srcUser="UNKNOWN";
		dstUser="UNKNOWN";
		TimeValue::getCurrentSystemTime(start);
	}

        ~SessionData(){
		log(3);
	}

	int log(int loglevel){
		TimeValue 	t;
		
		TimeValue::getCurrentSystemTime(t);
		t = t-start;

		if (t.tv_sec<=0) t.tv_sec=1; 
		LOG((__FILE__,__FUNCTION__,loglevel,"%s: OWNER(from=(%s|%s) to=(%s|%s)) TIME(duration=%d) DATA(in=(%d KB|%d KB/s) out=(%d KB|%d KB/s))\n",
		type.c_str(),
		srcUser.c_str(),(String::IPtoString(srcIP)).c_str(),
		dstUser.c_str(),(String::IPtoString(dstIP)).c_str(),
		t.tv_sec,
		read/1024,(read/1024)/(t.tv_sec),
		write/1024,(write/1024)/(t.tv_sec)))
	}
};

#endif
