/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */

#ifndef _String_h_
#define _String_h_ 1

#include "Thread.h"

#define String P_String

static const unsigned int maxP_StringLength = 256;
static Mutex stringLock;

class P_String {
	char rep[maxP_StringLength];
	unsigned int len;
	static unsigned int getLengthFromCharP(const char* s); 
public:
	P_String();
	P_String( const P_String& s );
	P_String( const char* s );
	P_String( const char c );
	~P_String(); 
	P_String& operator=( const P_String& s );
	P_String& operator=( const char* s ); 
	P_String& operator=( const char c ); 
	P_String& operator+=( const P_String& s );
	P_String& operator+=( const char* s );
	P_String operator+( const P_String& s1 );
	P_String& operator=( int i );
	P_String& operator+=( int i ); 
	P_String operator+( int i );
	const char* c_str() const;
	bool operator==( const P_String& s ) const;
	bool operator==( const char* s ) const;
	bool leftequal( const P_String& s ) const;
	bool leftequal( const char* s ) const;
	bool operator!=( const P_String& s ) const;
	bool operator!=( const char* s ) const;
	bool operator<( const P_String& s ) const;
	bool operator<( const char* s ) const;
	bool empty() const;
	unsigned int size() const;
	char operator[](int i) const; 
	static P_String IPtoString(int ip);
	int c_int();
};
#endif /* _String_h_ */
