/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */


#ifndef _Thread_h_
#define _Thread_h_ 1

#include <pthread.h>	/* thread */

#define MUTEX_AUTO_LOCK(x) MutexLock lockJofel(x)

class Thread {
	pthread_t ID;
	static void* runner( void* t );
protected:
	virtual void main() = 0;
public:
	bool end;

	Thread();
	virtual ~Thread();

	void 			run();
	virtual void 		stop();
	void 			join();
	void 			kill();
	void 			alarm();
	unsigned int 		myID();
	static unsigned int 	currentID();
};

class Mutex {
	bool initialized;
	pthread_mutex_t theLock;
public:
	Mutex();
	~Mutex(); 
	bool lock();
	void unlock();
};

class MutexLock {
	Mutex& mutex;
public:
	MutexLock(Mutex& mutex);
	~MutexLock();
};

#endif /* _Thread_h_ */
