dnl
dnl ----------------------------------------
dnl standard functions parameter checks
dnl ----------------------------------------
dnl
AC_DEFUN(MN_ACCEPT_P3,
[
  AC_LANG_SAVE
  AC_LANG_CPLUSPLUS
  AC_CACHE_CHECK(
    [for 3rd parameter of accept],
    mn_cv_func_accept_p3,
    [ AC_TRY_COMPILE(
      [#include <sys/types.h>
       #include <sys/socket.h>
      ],
      [ socklen_t t;
        accept(0,0,&t);
      ],
      [ mn_cv_func_accept_p3="socklen_t"
      ],
      [ AC_TRY_COMPILE(
        [#include <sys/types.h>
        #include <sys/socket.h>
        ],
        [ size_t t;
          accept(0,0,&t);
        ],
        [ mn_cv_func_accept_p3="size_t"
        ],
        [ mn_cv_func_accept_p3="int"
        ])
      ])
    ])
  AC_DEFINE_UNQUOTED(ACCEPT_SIZE_T,$mn_cv_func_accept_p3)
  AC_LANG_RESTORE
])


dnl AIX and FreeBSD have sockaddr_in.sin_len
dnl
AC_DEFUN(MN_HAVE_SIN_LEN,
[
  AC_LANG_SAVE
  AC_LANG_CPLUSPLUS
  AC_CACHE_CHECK(
    [for struct sockaddr_in has sin_len],
    mn_cv_func_sin_len,
    [ AC_TRY_COMPILE(
      [#include <sys/types.h>
       #include <sys/socket.h>
       #include <netinet/in.h>
      ],
      [ struct sockaddr_in x;
        x.sin_len = sizeof (x);
      ],
      [ mn_cv_func_sin_len="yes"
      ],
      [ mn_cv_func_sin_len="no"
      ])
    ])
  if test "Xyes" = "X$mn_cv_func_sin_len" ; then
    AC_DEFINE(HAVE_SIN_LEN)
  fi
  AC_LANG_RESTORE
])

