/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */





#include "GenericParser.h"
#include "../Log.h"
#include "../Session.h"

GenericParser::GenericParser(Session* parent_t,String type_t) {
	LOG((__FILE__,__FUNCTION__,15,"GENERIC: creating parser\n"))
	type=type_t;
	parent=parent_t;
}

GenericParser::~GenericParser() {
	LOG((__FILE__,__FUNCTION__,15,"GENERIC: deleting parser\n"))
}

int GenericParser::connectDestinationSPECIAL(String locator){
	return(-1);
}
int GenericParser::connectDestinationFAST(){
	return(connectDestination());
}

int GenericParser::write_0(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: write_0\n"))
	if(dc->connectionWrite(sc)<0) {
                WRN((__FILE__,__FUNCTION__,"GENERIC: write on socket\n"))
                return(-1);
        }
        return(sc->packet_len);
}
int GenericParser::write_1(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: write_1\n"))
	return(-1);
}
int GenericParser::write_2(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: write_2\n"))
	return(-1);
}
int GenericParser::write_3(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: write_3\n"))
	return(-1);
}
int GenericParser::write_default(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: write_default\n"))
	if(dc->connectionWrite(sc)<0) {
                WRN((__FILE__,__FUNCTION__,"GENERIC: write on socket\n"))
                return(-1);
        }
        return(sc->packet_len);
}
	

int GenericParser::read_0(Connection *c){
        int     len=0;
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: read_0\n"))
	c->zeroBuffer();
        if ((len=c->connectionRead(BUFFERSIZE-1))<0) return(-1);
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: read_0, length: %d\n",len))
        return(c->packet_len);
}
int GenericParser::read_1(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: read_1\n"))
	return(-1);
}
int GenericParser::read_2(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: read_2\n"))
	return(-1);
}
int GenericParser::read_3(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: read_3\n"))
	return(-1);
}
int GenericParser::read_default(Connection *c){
        int     len=0;
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: read_0\n"))
	c->zeroBuffer();
        if ((len=c->connectionRead(BUFFERSIZE-1))<0) return(-1);
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: read_0, length: %d\n",len))
        return(c->packet_len);
}

int GenericParser::parse_00(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_00\n"))
	return(1);
}

int GenericParser::parse_10(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_10\n"))
	return(1);
}
int GenericParser::parse_20(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_20\n"))
	return(1);
}
int GenericParser::parse_30(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_30\n"))
	return(1);
}
int GenericParser::parse_default0(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_default0\n"))
	return(1);
}
int GenericParser::parse_01(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_01\n"))
	return(1);
}
int GenericParser::parse_11(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_11\n"))
	return(1);
}
int GenericParser::parse_21(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_21\n"))
	return(1);
}
int GenericParser::parse_31(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_31\n"))
	return(1);
}
int GenericParser::parse_default1(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"GENERIC: parse_default1\n"))
	return(1);
}

