/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#ifndef _H323Call_h_
#define _H323Call_h_ 1

#include "../Global.h"
#include "../Fwhndl.h"

#define MAXMEDIACHANNELS        6

class H323MediaChannel;
class Session;
class Connection;

class H323Call {
	int q931;
	int h245;
public:
	Connection      	**Q931_in;
	Connection      	**Q931_out;
	Connection      	**H245_in;
	Connection      	**H245_out;
	H323MediaChannel 	*mediaChannel[MAXMEDIACHANNELS];
	int 			id;

	Fwhndl  		fwhndl;

        H323Call();
	~H323Call();

	int getMediaChannel(int id_a,int id_b);			/* returns the index i of the mediaChannel[i] used for the media with the specific id */ 
	int delMediaChannel(int id_a,int id_b);			/* delete the mediaChannel[i] used for the media with the specific id, return 0/-1 */
	int setMediaChannel(Session* parent); 			/* allocate new mediaChannel[i], return i */
	int useMediaChannel(Session* parent,int id_a,int id_b);	/* fill the mediaChannel[i] RTP/RTCP set them in connect, return i */

	int getH245Channel();			/* returns the index i of the con[i][x] that is used for the H245 channel, return i */
	int delH245Channel();			/* delete the con[i][0] con[i][1] used for the H245 channel, set H245_in and H245_out to NULL, return i*/
	int setH245Channel(Session* parent);	/* allocate new con[i][0] con[i][1] for the H245 channel, set H245_in and H245_out to con[i][0] and con[i][1], return i */
	int useH245Channel(Session* parent);	/* fill the con[i][0] con[i][1] structure and set con[i][0] in listen mode, return i */

	int getQ931Channel();			/* returns the index i of the con[i][x] that is used for the Q931 channel, return i */
	int delQ931Channel();			/* delete the con[i][0] con[i][1] used for the Q931 channel, set Q931_in and Q931_out to NULL, return i */
	int setQ931Channel(Session* parent);	/* allocate new con[i][0] con[i][1] for the Q931 channel, set Q931_in and Q931_out to con[i][0] and con[i][1], return i */
	int useQ931Channel(Session* parent);	/* allocate new con[i][0] con[i][1] for the Q931 channel, set Q931_in and Q931_out to con[i][0] and con[i][1], return i */
};

#endif
