/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#include "FirewallControlIpflfw.h"
#include "../FirewallControl.h"
#include "../Log.h"
#include "../Conf.h"

#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <net/if.h>
#include <fcntl.h>

#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <strings.h>
#include <sys/time.h>
#include <sys/param.h>
#include <stddef.h>
#include <sys/ioccom.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <net/if_var.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <resolv.h>
#include <ctype.h>
#include <netinet/ip_compat.h>
#include <netinet/ip_fil.h>
#include <netinet/ip_proxy.h>
#include <netinet/ip_nat.h>
#include <ip_compat.h>
#include <ip_fil.h>
#include <ip_nat.h>
#include <ip_state.h>
#include <ipf.h>
#include <ipl.h>



FirewallControlIpflfw::FirewallControlIpflfw(String type_t){
	type=type_t;
}

FirewallControlIpflfw::~FirewallControlIpflfw(){
}

int FirewallControlIpflfw::fw_get_chl_x(Fwfil *fwfilp){
	LOG((__FILE__,__FUNCTION__,15,"ipfilter fw\n"))
        int     fd = -1;
#ifdef IPFIL33
        struct  frentry fil;
#endif
#ifdef IPFIL34
        struct  frentry fil, *filptr = &fil;
#endif

        if ((fd = open(IPL_NAME, O_RDWR)) == -1) {
               LOG((__FILE__,__FUNCTION__,1,"could not open %s\n", IPL_NAME))
                return (-1);
        }

        bzero((char *)&fil, sizeof(fil));

        fil.fr_group    =      	Global::getGlobal()->getConf()->getValAsInt("IPFL_GROUP"); 
        fil.fr_ip.fi_v  =       4;
        fil.fr_mip.fi_v =       0xf;
        fil.fr_loglevel =       0xffff;
        fil.fr_flags    |=      FR_PASS;
        fil.fr_flags    |=      FR_INQUE;
        fil.fr_flags    |=      FR_QUICK;
        fil.fr_mip.fi_p =       0xff;
        fil.fr_proto    =       fwfilp->ipproto;

        fil.fr_src.s_addr  = fwfilp->srchost;
        fil.fr_smsk.s_addr = fwfilp->srcmask;
        fil.fr_scmp        = fwfilp->srcportrange;
        fil.fr_sport       = fwfilp->srcport;

        fil.fr_dst.s_addr  = fwfilp->dsthost;
        fil.fr_dmsk.s_addr = fwfilp->dstmask;
        fil.fr_dcmp        = fwfilp->dstportrange;
        fil.fr_dport       = fwfilp->dstport;

        if ((fwfilp->ipproto)==6) {
                //fil.fr_flags |= FR_KEEPSTATE;
                fil.fr_tcpf |= fwfilp->tcpf;
                fil.fr_tcpfm |= fwfilp->tcpf;
        }

#ifdef IPFIL33
        if (ioctl(fd, SIOCADAFR, &fil) == -1){
#endif
#ifdef IPFIL34
        if (ioctl(fd, SIOCADAFR, &filptr) == -1){
#endif
               LOG((__FILE__,__FUNCTION__,1,"ioctl(SIOCADDFR)\n"))
                close(fd);
                return (-1);
        }
        close(fd);
        return(0);
}

int FirewallControlIpflfw::fw_del_chl_x(Fwfil *fwfilp){
	LOG((__FILE__,__FUNCTION__,15,"ipfilter fw\n"))
        int     fd = -1;
        int     slp= 2;
        int     cnt= 0;
        int     err=0;
#ifdef IPFIL33
        struct  frentry fil;
#endif
#ifdef IPFIL34
        struct  frentry fil, *filptr = &fil;
#endif

        if ((fd = open(IPL_NAME, O_RDWR)) == -1) {
               LOG((__FILE__,__FUNCTION__,1,"could not open %s\n", IPL_NAME))
                return (-1);
        }

        bzero((char *)&fil, sizeof(fil));

        fil.fr_group    =       Global::getGlobal()->getConf()->getValAsInt("IPFL_GROUP");
        fil.fr_ip.fi_v  =       4;
        fil.fr_mip.fi_v =       0xf;
        fil.fr_loglevel =       0xffff;
        fil.fr_flags    |=      FR_PASS;
        fil.fr_flags    |=      FR_INQUE;
        fil.fr_flags    |=      FR_QUICK;
        fil.fr_mip.fi_p =       0xff;
        fil.fr_proto    =       fwfilp->ipproto;

        fil.fr_src.s_addr  = fwfilp->srchost;
        fil.fr_smsk.s_addr = fwfilp->srcmask;
        fil.fr_scmp        = fwfilp->srcportrange;
        fil.fr_sport       = fwfilp->srcport;

        fil.fr_dst.s_addr  = fwfilp->dsthost;
        fil.fr_dmsk.s_addr = fwfilp->dstmask;
        fil.fr_dcmp        = fwfilp->dstportrange;
        fil.fr_dport       = fwfilp->dstport;

        if ((fwfilp->ipproto)==6) {
                // fil.fr_flags |= FR_KEEPSTATE;
                fil.fr_tcpf  |= fwfilp->tcpf;
                fil.fr_tcpfm |= fwfilp->tcpf;
        }

        while (cnt<=2){
#ifdef IPFIL33
                if (ioctl(fd, SIOCDELFR, &fil) == -1){
#endif
#ifdef IPFIL34
                if (ioctl(fd, SIOCDELFR, &filptr) == -1){
#endif
                        if (errno==EBUSY)  {
                               LOG((__FILE__,__FUNCTION__,2,"ioctl(SIOCDELFR) BUSY\n"))
                                cnt++;
                                slp=slp*cnt;
                               LOG((__FILE__,__FUNCTION__,2,"could not remove rule, #%d retry in %d seconds\n",cnt,slp))
                                sleep(slp);
                        }
                        else {
                               LOG((__FILE__,__FUNCTION__,2,"ioctl(SIOCDELFR) ERROR\n"))
                                close(fd);
                                return (-2);
                        }
                }
                else {
                        close(fd);
                        return(0);
                }
        }
        return(-1);
}
int FirewallControlIpflfw::fw_get_dst_x(Connection *sc,Connection *dc){
	LOG((__FILE__,__FUNCTION__,15,"ipfilter fw\n"))
        struct sockaddr_in      sin;
        struct sockaddr_in      rsin;
        int                     sl;
        int                     natfd;
#ifdef IPFIL33
        struct natlookup natlookup;
#endif
#ifdef IPFIL34
        struct natlookup natlookup, *nlptr = &natlookup;
#endif

        bzero((char*)&sin, sizeof(sin));
        bzero((char*)&rsin, sizeof(rsin));

        sl = sizeof(sin);
        if (getsockname(sc->get_fd(), (struct sockaddr*)&sin, &sl) < 0) {
               LOG((__FILE__,__FUNCTION__,1,"getsockname\n"))
                return (-1);
        }

        sl = sizeof(rsin);
        if(getpeername(sc->get_fd(), (struct sockaddr*)&rsin, &sl) < 0) {
               LOG((__FILE__,__FUNCTION__,1,"getsockname\n"))
                return(-1);
        }

        natlookup.nl_inport=sin.sin_port;
        natlookup.nl_outport=rsin.sin_port;
        natlookup.nl_inip=sin.sin_addr;
        natlookup.nl_outip=rsin.sin_addr;
        natlookup.nl_flags = IPN_TCP;

        if ((natfd = open(IPL_NAT,O_RDONLY)) < 0) {
               LOG((__FILE__,__FUNCTION__,1,"open IPL_NAT\n"))
                return (-1);
        }
#ifdef IPFIL33
        if (ioctl( natfd, SIOCGNATL, &natlookup )  == (-1)) {
#endif
#ifdef IPFIL34
        if (ioctl(natfd, SIOCGNATL ,  &nlptr) == (-1)) {
#endif
               LOG((__FILE__,__FUNCTION__,1,"ioctl errno=%d\n",errno))
                return (-1);
        }

        close(natfd);

        dc->p_ip   = natlookup.nl_realip.s_addr;
	dc->p_mask = 0xffffffff;
        dc->p_port = ntohs(natlookup.nl_realport);

        return(0);
}


