/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#ifndef _RASParser_h_
#define _RASParser_h_ 1

#include "../Global.h"
#include "../Parser.h"
#include "../Connection.h"
#include "../TimeValue.h"
#include "../String.h"
#include "../Fwfil.h"

#include <ptlib.h>
#include <h225.h>
#include <h225ras.h>

/*#define _H323DEBUG_ 1*/

#define TPKT_LENGTH_OFFSET      2
#define MAXLRQ     		10 

class RASParser : public Parser {
	int			  lrqring;
	int                       lrqRequestSeqNum[MAXLRQ];
	H225_ArrayOf_AliasAddress lrqDestinationInfo[MAXLRQ];
	H225_TransportAddress     lrqRequestReplyAddress[MAXLRQ];

	int connectDestinationDestinationAddressPDU(H225_ArrayOf_AliasAddress* destinationAddress);
	int connectDestinationReplyAddressPDU(H225_TransportAddress* replyAddress);


	bool checkPDU(String pdutype);
	int setReplyAddress(H225_TransportAddress* replyAddress);
	int setCallSignalAddress(H225_TransportAddress* callSignalAddress);
	int setRasAddress(H225_TransportAddress* rasAddress);
	int setCallRoutingEntry(H225_TransportAddress* callSignalAddress,H225_TransportAddress* rasAddress,H225_ArrayOf_AliasAddress* destinationInfo);
public:
	RASParser(Session* parent_t,String type_t);
	~RASParser();
	
        int connectDestinationSPECIAL(String locator);
        int connectDestinationFAST();

	int read_0(Connection *c);
	int read_1(Connection *c);
	int read_2(Connection *c);
	int read_3(Connection *c);
	int read_default(Connection *c);

	int write_0(Connection *dc, Connection *sc);
	int write_1(Connection *dc, Connection *sc);
	int write_2(Connection *dc, Connection *sc);
	int write_3(Connection *dc, Connection *sc);
	int write_default(Connection *dc, Connection *sc);
	
	int parse_00(Connection *c);
	int parse_10(Connection *c);
	int parse_20(Connection *c);
	int parse_30(Connection *c);
	int parse_default0(Connection *c);
	int parse_01(Connection *c);
	int parse_11(Connection *c);
	int parse_21(Connection *c);
	int parse_31(Connection *c);
	int parse_default1(Connection *c);

};

#ifndef STATIC_PROXY
extern "C" {
Parser *maker(Session* parent_t,String type_t){
   return new RASParser(parent_t,type_t);
}
}
#endif


#endif
