/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */





#include "RTSPParser.h"
#include "../Log.h"

RTSPParser::RTSPParser(Session* parent_t,String type_t) {
	type=type_t;
	parent=parent_t;
}

RTSPParser::~RTSPParser() {
}

int RTSPParser::connectDestinationSPECIAL(String locator){
	return(-1);
}
int RTSPParser::connectDestinationFAST(){
	return(connectDestination());
}

int RTSPParser::write_0(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"write_0\n"))
	if(dc->connectionWrite(sc)<0) {
                WRN((__FILE__,__FUNCTION__,"write on socket\n"))
                return(-1);
        }
        return(sc->packet_len);
}
int RTSPParser::write_1(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"write_1\n"))
	return(-1);
}
int RTSPParser::write_2(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"write_2\n"))
	return(-1);
}
int RTSPParser::write_3(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"write_3\n"))
	return(-1);
}
int RTSPParser::write_default(Connection *dc, Connection *sc){
        LOG((__FILE__,__FUNCTION__,15,"write_default\n"))
	if(dc->connectionWrite(sc)<0) {
                WRN((__FILE__,__FUNCTION__,"write on socket\n"))
                return(-1);
        }
        return(sc->packet_len);
}
	

int RTSPParser::read_0(Connection *c){
        int     len=0;
        LOG((__FILE__,__FUNCTION__,15,"read_0\n"))
	c->zeroBuffer();
        if ((len=c->connectionRead(BUFFERSIZE-1))<0) return(-1);
        LOG((__FILE__,__FUNCTION__,15,"read_0, length: %d\n",len))
        return(c->packet_len);
}
int RTSPParser::read_1(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"read_1\n"))
	return(-1);
}
int RTSPParser::read_2(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"read_2\n"))
	return(-1);
}
int RTSPParser::read_3(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"read_3\n"))
	return(-1);
}
int RTSPParser::read_default(Connection *c){
        int     len=0;
        LOG((__FILE__,__FUNCTION__,15,"read_0\n"))
	c->zeroBuffer();
        if ((len=c->connectionRead(BUFFERSIZE-1))<0) return(-1);
        LOG((__FILE__,__FUNCTION__,15,"read_0, length: %d\n",len))
        return(c->packet_len);
}

int RTSPParser::parse_00(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_00\n"))
	return(-1);
}

int RTSPParser::parse_10(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_10\n"))
	return(-1);
}
int RTSPParser::parse_20(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_20\n"))
	return(-1);
}
int RTSPParser::parse_30(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_30\n"))
	return(-1);
}
int RTSPParser::parse_default0(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_default0\n"))
	return(-1);
}
int RTSPParser::parse_01(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_01\n"))
	return(-1);
}
int RTSPParser::parse_11(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_11\n"))
	return(-1);
}
int RTSPParser::parse_21(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_21\n"))
	return(-1);
}
int RTSPParser::parse_31(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_31\n"))
	return(-1);
}
int RTSPParser::parse_default1(Connection *c){
        LOG((__FILE__,__FUNCTION__,15,"parse_default1\n"))
	return(-1);
}

