/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#ifndef _SIPCall_h_
#define _SIPCall_h_ 1

#include "../Global.h"
#include "../Fwhndl.h"

extern "C" {
#include <osip/smsg.h>
#include <osip/sdp.h>

}

#define MAXMEDIACHANNELS	2 

class SIPMediaChannel;
class Session;
class Connection;

class SIPCall {
	static int sip;
public:
	static Connection      	**SIP_in;
	static Connection      	**SIP_out;
	SIPMediaChannel 	*mediaChannel[MAXMEDIACHANNELS];

	Fwhndl  fwhndl;

	int 	id;
        int	s_ip;
        int	s_port;
	int	d_ip;
	int	d_port;

	sip_t  *msg_in;
	sip_t  *msg_out;

	bool	callEnd;

        SIPCall();
	~SIPCall();

	static String getCallId(sip_t  *msg);

	int getMediaChannel(int id_a,int id_b);			/* returns the index i of the mediaChannel[i] used for the media with the specific id */ 
	int delMediaChannel(int id_a,int id_b);			/* delete the mediaChannel[i] used for the media with the specific id, return 0/-1 */
	int setMediaChannel(Session* parent); 			/* allocate new mediaChannel[i], return i */
	int useMediaChannel(Session* parent,int id_a,int id_b);	/* fill the mediaChannel[i] RTP/RTCP set them in connect, return i */

	static int getSIPChannel();			/* returns the index i of the con[i][x] that is used for the SIP channel, return i */
	static int delSIPChannel();			/* delete the con[i][0] con[i][1] used for the SIP channel, set SIP_in and SIP_out to NULL, return i */
	static int setSIPChannel(Session* parent);	/* allocate new con[i][0] con[i][1] for the SIP channel, set SIP_in and SIP_out to con[i][0] and con[i][1], return i */
	static int useSIPChannel(Session* parent,int port);	/* allocate new con[i][0] con[i][1] for the SIP channel, set SIP_in and SIP_out to con[i][0] and con[i][1], return i */
};

#endif
