/* Copyright (C) 2000 KOM/Darmstadt University of Technology
 *
 * You are allowed to use all other parts of the code under the following terms:
 *
 * For non-commercial use, code may be used in unmodified form provided
 * that this copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This software is provided "as is" and without any express or implied
 * warranties, including, without limitation, the implied warranty of
 * fitness for a particular purpose.
 *
 * The code may be subjected to the GNU General Public License, Version 2,
 * and re-distributed under the terms of this license.
 *
 * Commercial use other than under the terms of the GNU General Public
 * License is allowed only after express negotiation of conditions
 * with the authors.
 */
#ifndef _SIPSIPMediaChannel_h_
#define _SIPSIPMediaChannel_h_ 1

#include "../Global.h"

class Session;
class Connection;

class SIPMediaChannel{
	int		rtp;
	int		rtcp;
public:
	int		id_a;	/* id */
	int		id_b;	/* identifier to distinguish the direction */ 
	Connection	**RTP_in;
	Connection	**RTCP_in;
	Connection	**RTP_out;
	Connection	**RTCP_out;
	
	SIPMediaChannel();
	~SIPMediaChannel();
	
	int getMediaChannelRTCP();				/* returns the index i of the con[i][x] that is used for the RTCP channel, return i */
	int getMediaChannelRTP();				/* returns the index i of the con[i][x] that is used for the RTP channel, return i */		
        int delMediaChannel();					/* delete the con[i][0] con[i][1] con[j][0] con[j][1], used for the RTCP/RTP channel, return 0/-1 */
        int setMediaChannel(Session* parent); 			/* allocate new con[i][0] con[i][1] con[j][0] con[j][1], set RTP_in RTCP_in RTP_out RTCP_out, return i*/
        int useMediaChannel(Session* parent,int id_a_t,int id_b_t); /* fill the mediaChannel[i] RTP/RTCP set them in connect, return i */
};

#endif
